SELECT        ST.SalesTerritoryCountry, D.CalendarYear, DimProductCategory.EnglishProductCategoryName AS ProductCategory, 
                         DimProductSubcategory.EnglishProductSubcategoryName AS ProductSubcategory, DimProduct.EnglishProductName AS ProductName, 
                         SUM(FactResellerSales.SalesAmount) AS ResellerSales, SUM(FactInternetSales.SalesAmount) AS InternetSales
FROM            DimProduct INNER JOIN
                         DimProductSubcategory ON DimProduct.ProductSubcategoryKey = DimProductSubcategory.ProductSubcategoryKey INNER JOIN
                         DimProductCategory ON DimProductSubcategory.ProductCategoryKey = DimProductCategory.ProductCategoryKey INNER JOIN
                         FactInternetSales ON DimProduct.ProductKey = FactInternetSales.ProductKey INNER JOIN
                         FactResellerSales ON DimProduct.ProductKey = FactResellerSales.ProductKey INNER JOIN
                         DimDate AS D ON FactInternetSales.OrderDateKey = D.DateKey AND FactResellerSales.OrderDateKey = D.DateKey INNER JOIN
                         DimSalesTerritory AS ST ON FactInternetSales.SalesTerritoryKey = ST.SalesTerritoryKey AND 
                         FactResellerSales.SalesTerritoryKey = ST.SalesTerritoryKey
GROUP BY DimProduct.EnglishProductName, DimProductCategory.EnglishProductCategoryName, DimProductSubcategory.EnglishProductSubcategoryName, 
                         ST.SalesTerritoryCountry, D.CalendarYear
ORDER BY ProductCategory, ProductSubcategory, ProductName