using System;
using System.IO;
using System.Web;
using System.Collections;
using System.Collections.Generic;
using System.Web.Services;
using System.Web.Services.Protocols;


/// <summary>
/// Summary description for GetMap
/// </summary>
[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class Customers : System.Web.Services.WebService {

    public Customers()
	{

    }

	/// <summary>
	/// Return the customer map image
	/// </summary>
	/// <param name="customerID"></param>
	/// <returns>Byte array</returns>
	[WebMethod]
	public CustomerOrders.SalesOrderHeaderDataTable GetOrders(int customerID)
	{
		CustomerOrdersTableAdapters.SalesOrderHeaderTableAdapter adapter = new CustomerOrdersTableAdapters.SalesOrderHeaderTableAdapter();
		// The XML extension seems to ingore the web method parameter, so hardcode it for now
        CustomerOrders.SalesOrderHeaderDataTable orders = adapter.GetData(customerID);

		return orders;
	}

    public class Product
    {
        private string m_name;
        private int m_price;

        public Product()
        {
        }
        public Product(string name, int price)
        {
            m_name = name;
            m_price = price;
        }

        public string Name
        {
            get
            {
                return m_name;
            }
        }

        public int Price
        {
            get
            {
                return m_price;
            }
        }
    }

    public class Merchant
    {
        private List<Product> m_products;

        public Merchant()
        {
            m_products = new List<Product>();
            m_products.Add(new Product("Pen", 25));
            m_products.Add(new Product("Pencil", 30));
            m_products.Add(new Product("Notebook", 15));
        }

        public List<Product> GetProducts()
        {
            return m_products;
        }
    }


    [WebMethod]
    public List<Product> GetOrdersAsObject(int customerID)
    {
        return new Merchant().GetProducts();

    }
}

