﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.IO;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Configuration;

[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class Service : System.Web.Services.WebService
{
    public Service () {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }

    [WebMethod]
    public decimal GetRate(DateTime date, string currency) {
        decimal rate = 0;
        string sql = "SELECT [AverageRate] FROM [Sales].[CurrencyRate] WHERE CurrencyRateDate = @Date AND ToCurrencyCode = @Currency";
        using (SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["AdventureWorksConnectionString"].ConnectionString))
        {
            SqlCommand cmd = new SqlCommand(sql, conn);
            cmd.Parameters.Add("@Date", SqlDbType.DateTime);
            cmd.Parameters.Add("@Currency", SqlDbType.NChar, 3);
            cmd.Parameters["@Date"].Value = date;
            cmd.Parameters["@Currency"].Value = currency;
            try
            {
                conn.Open();
                rate = (Decimal)cmd.ExecuteScalar();
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        return rate;
    }
    [WebMethod]
    public byte[] GetMap(int customerID)
    {
        string imagePath = "";

        imagePath = String.Format(@"{0}\{1}.gif", Server.MapPath("images"), customerID);

        if (File.Exists(imagePath))
            return FileAsBytes(imagePath);
        else
            return new byte[] { };
    }

    private static byte[] FileAsBytes(string fileName)
    {
        FileStream stream = new FileStream(fileName, FileMode.Open, FileAccess.Read, FileShare.Read);
        stream.Seek(0, SeekOrigin.Begin);
        byte[] fileBytes = new byte[stream.Length];
        stream.Read(fileBytes, 0, Convert.ToInt32(stream.Length));
        return fileBytes;
    }
    
}
