#region Disclaimer by Teo Lachev
/*============================================================================
  File:      Logon.cs

  Summary:	The code-behind for a logon page that supports Forms Authentication 
			in a custom security extension  
--------------------------------------------------------------------
  This code sample was built upon on the Microsoft Custom Security sample 
  http://tinyurl.com/33lhoy
 
    
===========================================================================*/
#endregion

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Security.Cryptography;
using System.Web.Security;
using Microsoft.ReportingServices.Interfaces;
using System.Globalization;

namespace Prologika.RS.Extensibility.CustomSecurityExtension
{
   public class Logon : System.Web.UI.Page
   {
      protected System.Web.UI.WebControls.Label LblUser;
      protected System.Web.UI.WebControls.TextBox TxtPwd;
      protected System.Web.UI.WebControls.TextBox TxtUser;
      protected System.Web.UI.WebControls.Button BtnRegister;
      protected System.Web.UI.WebControls.Button BtnLogon;
      protected System.Web.UI.WebControls.Label lblMessage;
      protected System.Web.UI.WebControls.Label Label1;
      protected System.Web.UI.WebControls.Label LblPwd;

      private void Page_Load(object sender, System.EventArgs e)
      {

      }

      #region Web Form Designer generated code
      override protected void OnInit(EventArgs e)
      {
            InitializeComponent();
            base.OnInit(e);
      }
      
      private void InitializeComponent()
      {    
         this.BtnLogon.Click += new System.EventHandler(this.ServerBtnLogon_Click);
         this.BtnRegister.Click += new System.EventHandler(this.BtnRegister_Click);
         this.Load += new System.EventHandler(this.Page_Load);

      }
      #endregion

      private void BtnRegister_Click(object sender, 
         System.EventArgs e)
      {
         string salt = AuthenticationUtilities.CreateSalt(5);
         string passwordHash =
            AuthenticationUtilities.CreatePasswordHash(TxtPwd.Text, salt);
         if (AuthenticationUtilities.ValidateUserName(TxtUser.Text))
         {
            try
            {
               AuthenticationUtilities.StoreAccountDetails(
                  TxtUser.Text, passwordHash, salt);
            }
            catch(Exception ex)
            {
              lblMessage.Text = string.Format(CultureInfo.InvariantCulture, ex.Message);
            }
         }
         else
         {

           lblMessage.Text = string.Format(CultureInfo.InvariantCulture,
               "The user name that was entered contains characters not supported by report server custom authentication.");
         }
      }

      private void ServerBtnLogon_Click(object sender, System.EventArgs e)
      {
         bool passwordVerified = false;
         try
         {

             if ((0 == String.Compare(TxtUser.Text, "admin", true, CultureInfo.CurrentCulture)) && (TxtPwd.Text == "admin"))
                 passwordVerified = true;

            if (passwordVerified)
            {
               FormsAuthentication.RedirectFromLoginPage(TxtUser.Text, false);
            }
            else
            {
               Response.Redirect("logon.aspx");
            }
         }
         catch(Exception ex)
         {
           lblMessage.Text = string.Format(CultureInfo.InvariantCulture, ex.Message);
            return;
         }
         if (passwordVerified == true )
         {
            // The user is authenticated
            // At this point, an authentication ticket is normally created
            // This can subsequently be used to generate a GenericPrincipal
            // object for .NET authorization purposes
            // For details, see "How To: Use Forms authentication with 
            // GenericPrincipal objects
           lblMessage.Text = string.Format(CultureInfo.InvariantCulture,
              "Logon successful: User is authenticated.");
         }
         else
         {
           lblMessage.Text = string.Format(CultureInfo.InvariantCulture,
             "Invalid username or password");
         }
      }
   }
}
