using System;
using System.Web;
using System.Data;
using System.Data.SqlClient;
using System.Globalization;
using System.Text.RegularExpressions;

namespace Prologika.RS.Extensibility.CustomSecurityExtension
{
	/// <summary>
	/// Summary description for Util.
	/// </summary>
	public class Util
	{
		public static string DATA_SOURCE = "@DataSource";
		public static string DATA_MEMBER = "@DataMember";
		private static Regex regEx = new Regex(@"^[-+]?\d*\.?\d*$",RegexOptions.Compiled);

		internal static bool IsNumeric(string sValue) 
		{ 
			if (sValue == null) return false;
			sValue = sValue.Trim();
			return ((regEx.IsMatch(sValue)) && (sValue.Length>0));
		}

		/// <summary>
		/// Returns the roles that belongs to user
		/// </summary>
		/// <param name="principalName">The user id</param>
		/// <returns>A data reader with with all roles</returns>
		internal static DataSet GetUserRoles(string principalName)
		{
			SqlDataAdapter adapter = null; 
			DataSet roles = new DataSet();
			SqlConnection conn = new SqlConnection(AuthenticationExtension.ConnectionString);

			SqlCommand cmd = new SqlCommand(Constants.USP_USER_ROLES, conn);
			cmd.CommandType = CommandType.StoredProcedure;

            SqlParameter sqlParam = cmd.Parameters.Add("@PrincipalName", SqlDbType.Int, 4);
			sqlParam.Value = principalName;

			adapter = new SqlDataAdapter(cmd);
			
			try
			{
				adapter.Fill(roles);
			}
			catch (Exception ex)
			{
				throw new Exception("An error occurred while attempting to " + 
					"verify the user. " + ex.Message);
			}
			return roles;
		}
		internal static bool IsInRole (string userName, string role)
		{
			string[] roles = HttpContext.Current.Cache[userName] as string[];
			if (roles == null) 
				return false;
			else
			{
				foreach (string tempRole in roles)
				{
					if (0 == String.Compare(role, tempRole, true, CultureInfo.CurrentCulture)) return true;
				}
			}
			return false;
		}

	}


}
