using System;
using System.Collections;

using Microsoft.ReportingServices.Interfaces;

namespace Prologika.RS.Extensibility.CustomDeliveryExtension
{
	internal class SubscriptionData
	{
      
		// Initalize variables to default values
		public string WSDL				= String.Empty;
		public string methodName		= String.Empty;
               
		public SubscriptionData()
		{
			// TODO: Add constructor code here
		}
      
		// Populate the object from an array of setting elements
		// No validation is done, it is assumed that the settings
		// contains all relevant information
		public void FromSettings(Setting[] settings)
		{
			foreach (Setting setting in settings)
			{
				switch (setting.Name)
				{
					case (Constants.CONFIG_WSDL):
						this.WSDL = setting.Value.ToString();
						break;
					case (Constants.CONFIG_METHOD_NAME):
						this.methodName = setting.Value.ToString();
						break;
					default:
						break;
				}
			}
		}

		// Creates an array of the settings
		public Setting[] ToSettingArray()
		{
			ArrayList list = new ArrayList();

			list.Add(CreateSetting(Constants.CONFIG_WSDL, this.WSDL ));
			list.Add(CreateSetting(Constants.CONFIG_METHOD_NAME, this.methodName));
                  
			return list.ToArray(typeof(Setting)) as Setting[];
		}

		// Creates a single instance of a Setting
		private Setting CreateSetting(string name, string val)
		{
			Setting setting = new Setting();
			setting.Name = name;
			setting.Value = val;

			return setting;
		}
	}
}

