using System;
using System.Drawing;
using System.Collections.Generic;
using System.Text;

namespace Prologika.RS.Extensibility.ProgressTrackerCRI
{
    class Shared
    {
        #region Constants
        internal static string PROP_ALPHA               = "Alpha";
        internal static string PROP_PROGRESS_COLOR      = "ProgressColor";
        internal static string PROP_BORDER_COLOR        = "BorderColor";
        internal static string PROP_VALUE               = "Value";
        internal static string PROP_MINIMUM             = "Minimum";
        internal static string PROP_MAXIMUM             = "Maximum";
        internal static string PROP_SHOW_VALUE          = "ShowValue";
        internal static string PROP_HYPERLINK           = "Hyperlink";

        internal static int DPI = 96;
        #endregion
        internal static Color GetColorFromString(string color)
        {
            Color obj = Color.Empty;

            try
            {
                System.Drawing.ColorConverter convert = new System.Drawing.ColorConverter();

                if (string.Compare(color, "Empty", true) == 0)
                {
                    obj = System.Drawing.Color.Empty;
                }
                else
                {
                    obj = (System.Drawing.Color)convert.ConvertFromString(
                        null,
                        System.Globalization.CultureInfo.InvariantCulture,
                        color);
                }
            }
            catch
            {
                obj = System.Drawing.Color.Empty;
            }

            return obj;
        }

        internal static string GetStringFromColor(Color color)
        {
            string name = "";
            try
            {
                if (color.IsKnownColor || color.IsNamedColor || color.IsSystemColor)
                    name = color.Name;
                else
                {
                    System.Drawing.ColorConverter convert = new System.Drawing.ColorConverter();

                    name = (string)convert.ConvertToString(
                            null,
                            System.Globalization.CultureInfo.InvariantCulture,
                            color);
                }
            }
            catch
            {
                name = "";
            }

            return name;
        }

        //internal static Font GetDrawingFontFromReportFont(ReportFont reportFont)
        //{
        //    string fontStyle = "Regular";

        //    switch (reportFont.FontStyle)
        //    {
        //        case "Normal": fontStyle = "Regular"; break;
        //        case "Italic": fontStyle = "Italic"; break;

        //    }

        //    switch (reportFont.FontWeight.ToString())
        //    {
        //        case "Bold": fontStyle = "Bold"; break;
        //        default: fontStyle = "Regular"; break;
        //    }


        //    return new Font(reportFont.FontFamily, float.Parse(reportFont.FontSize.BaseUnit.Value.ToString()),
        //         (FontStyle)Enum.Parse(typeof(FontStyle), fontStyle));
        //}

        internal static Font GetDrawingFontFromReportFont(string fontFamily, string fontStyle, string fontWeight, float fontSize)
        {

            switch (fontStyle)
            {
                case "Normal": fontStyle = "Regular"; break;
                case "Italic": fontStyle = "Italic"; break;

            }

            switch (fontWeight.ToString())
            {
                case "Bold": fontStyle = "Bold"; break;
                default: fontStyle = "Regular"; break;
            }


            return new Font(fontFamily, fontSize,(FontStyle)Enum.Parse(typeof(FontStyle), fontStyle));
        }



    }
}
